/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.TipoOcupacion;
import com.rjconsultores.ventaboletos.service.TipoOcupacionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarTipoOcupacionController")
@Scope("prototype")
public class EditarTipoOcupacionController extends MyGenericForwardComposer {

    @Autowired
    private TipoOcupacionService tipoOcupacionService;
    private TipoOcupacion tipoOcupacion;
    private MyListbox tipoOcupacionList;
    private Button btnApagar;
    private Textbox txtNome;
    private Textbox txtCve;
    private BusquedaTipoOcupacionController busquedaTipoOcupacionController;
    private static Logger log = Logger.getLogger(EditarTipoOcupacionController.class);

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public TipoOcupacion getTipoOcupacion() {
        return tipoOcupacion;
    }

    public void setTipoOcupacion(TipoOcupacion tipoOcupacion) {
        this.tipoOcupacion = tipoOcupacion;
    }

    public Textbox getTxtCve() {
        return txtCve;
    }

    public void setTxtCve(Textbox txtCve) {
        this.txtCve = txtCve;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);
        busquedaTipoOcupacionController = (BusquedaTipoOcupacionController) Executions.getCurrent().getArg().get("busquedaTipoOcupacionController");
        tipoOcupacion = (TipoOcupacion) Executions.getCurrent().getArg().get("tipoOcupacion");
        tipoOcupacionList = (MyListbox) Executions.getCurrent().getArg().get("tipoOcupacionList");

        if (tipoOcupacion.getTipoocupacionId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        txtCve.getValue();

        try {
            tipoOcupacion.setActivo(Boolean.TRUE);
            tipoOcupacion.setFecmodif(Calendar.getInstance().getTime());
            tipoOcupacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<TipoOcupacion> lsTipoOcupacion =
                    tipoOcupacionService.buscar(tipoOcupacion.getDesctipo(),
                    tipoOcupacion.getCvetipoocupacion());

            boolean podeSalvar = false;
            if (lsTipoOcupacion.isEmpty()) {
                podeSalvar = true;
            } else {
                if (tipoOcupacion.getTipoocupacionId() != null) {
                    for (TipoOcupacion p : lsTipoOcupacion) {
                        if (p.getTipoocupacionId().equals(tipoOcupacion.getTipoocupacionId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }
            List<TipoOcupacion> lsTipoOcuapacionClave =
                    tipoOcupacionService.buscarClave(tipoOcupacion.getCvetipoocupacion());

            boolean podeSalvarClave = false;
            if (lsTipoOcuapacionClave.isEmpty()) {
                podeSalvarClave = true;
            } else {
                if (tipoOcupacion.getTipoocupacionId() != null) {
                    for (TipoOcupacion p : lsTipoOcuapacionClave) {
                        if (p.getTipoocupacionId().equals(tipoOcupacion.getTipoocupacionId())) {
                            podeSalvarClave = true;
                        }
                    }
                }
            }

            if (!podeSalvarClave) {
                Messagebox.show(
                        Labels.getLabel("editarTipoDomicilioController.MSG.clave"),
                        Labels.getLabel("editarTipoDomicilioController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
                return;
            }
            if (!podeSalvar) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarTipoOcupacionController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (tipoOcupacion.getTipoocupacionId() == null) {
                    tipoOcupacionService.suscribir(tipoOcupacion);
                    tipoOcupacionList.addItem(tipoOcupacion);
                } else {
                    tipoOcupacionService.actualizacion(tipoOcupacion);
                    tipoOcupacionList.updateItem(tipoOcupacion);
                }

                Messagebox.show(
                        Labels.getLabel("editarTipoOcupacionController.MSG.suscribirOK"),
                        Labels.getLabel("editarTipoOcupacionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
                busquedaTipoOcupacionController.refreshLista();
                closeWindow();
            }
        } catch (Exception ex) {
            log.error("editarTipoOcupacionController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTipoOcupacionController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) throws InterruptedException {
        int resp = Messagebox.show(
                Labels.getLabel("editarTipoOcupacionController.MSG.borrarPergunta"),
                Labels.getLabel("editarTipoOcupacionController.window.title"),
                Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

        if (resp == Messagebox.YES) {

            tipoOcupacionService.borrar(tipoOcupacion);

            Messagebox.show(
                    Labels.getLabel("editarTipoOcupacionController.MSG.borrarOK"),
                    Labels.getLabel("editarTipoOcupacionController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            tipoOcupacionList.removeItem(tipoOcupacion);

            closeWindow();
        }
    }
}
